Index: /extensions/pwgCumulus/CHANGELOG
===================================================================
--- /extensions/pwgCumulus/CHANGELOG	(revision 5201)
+++ /extensions/pwgCumulus/CHANGELOG	(revision 5201)
@@ -0,0 +1,21 @@
+pwgCumulus 0.3.0 - 2009-02-28
+================================
+* gestion des couleurs 
+
+pwgCumulus 0.2.0 - 2009-02-19
+================================
+* gestion de la taille des tags par ajout d'un paramètre coefficient
+* ajout du choix du type de présentation des tags dans le menu (icône)
+* on peut choisir le mode cumulus comme affichage par défaut des tags.
+
+pwgCumulus 0.1.2 - 2009-02-16
+================================
+* bug fix : les noms des tags doivent être encodés
+
+pwgCumulus 0.1.1 - 2009-02-16
+================================
+* url de mise à jour incorrecte
+
+pwgCumulus 0.1.0 - 2009-02-15
+================================
+* première version publique.
Index: /extensions/pwgCumulus/COPYING
===================================================================
--- /extensions/pwgCumulus/COPYING	(revision 5201)
+++ /extensions/pwgCumulus/COPYING	(revision 5201)
@@ -0,0 +1,339 @@
+		    GNU GENERAL PUBLIC LICENSE
+		       Version 2, June 1991
+
+ Copyright (C) 1989, 1991 Free Software Foundation, Inc.,
+ 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+			    Preamble
+
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+License is intended to guarantee your freedom to share and change free
+software--to make sure the software is free for all its users.  This
+General Public License applies to most of the Free Software
+Foundation's software and to any other program whose authors commit to
+using it.  (Some other Free Software Foundation software is covered by
+the GNU Lesser General Public License instead.)  You can apply it to
+your programs, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+  To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if you
+distribute copies of the software, or if you modify it.
+
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must give the recipients all the rights that
+you have.  You must make sure that they, too, receive or can get the
+source code.  And you must show them these terms so they know their
+rights.
+
+  We protect your rights with two steps: (1) copyright the software, and
+(2) offer you this license which gives you legal permission to copy,
+distribute and/or modify the software.
+
+  Also, for each author's protection and ours, we want to make certain
+that everyone understands that there is no warranty for this free
+software.  If the software is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original, so
+that any problems introduced by others will not reflect on the original
+authors' reputations.
+
+  Finally, any free program is threatened constantly by software
+patents.  We wish to avoid the danger that redistributors of a free
+program will individually obtain patent licenses, in effect making the
+program proprietary.  To prevent this, we have made it clear that any
+patent must be licensed for everyone's free use or not licensed at all.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.
+
+		    GNU GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License.  The "Program", below,
+refers to any such program or work, and a "work based on the Program"
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language.  (Hereinafter, translation is included without limitation in
+the term "modification".)  Each licensee is addressed as "you".
+
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+
+  1. You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+
+  2. You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) You must cause the modified files to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    b) You must cause any work that you distribute or publish, that in
+    whole or in part contains or is derived from the Program or any
+    part thereof, to be licensed as a whole at no charge to all third
+    parties under the terms of this License.
+
+    c) If the modified program normally reads commands interactively
+    when run, you must cause it, when started running for such
+    interactive use in the most ordinary way, to print or display an
+    announcement including an appropriate copyright notice and a
+    notice that there is no warranty (or else, saying that you provide
+    a warranty) and that users may redistribute the program under
+    these conditions, and telling the user how to view a copy of this
+    License.  (Exception: if the Program itself is interactive but
+    does not normally print such an announcement, your work based on
+    the Program is not required to print an announcement.)
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+
+    a) Accompany it with the complete corresponding machine-readable
+    source code, which must be distributed under the terms of Sections
+    1 and 2 above on a medium customarily used for software interchange; or,
+
+    b) Accompany it with a written offer, valid for at least three
+    years, to give any third party, for a charge no more than your
+    cost of physically performing source distribution, a complete
+    machine-readable copy of the corresponding source code, to be
+    distributed under the terms of Sections 1 and 2 above on a medium
+    customarily used for software interchange; or,
+
+    c) Accompany it with the information you received as to the offer
+    to distribute corresponding source code.  (This alternative is
+    allowed only for noncommercial distribution and only if you
+    received the program in object code or executable form with such
+    an offer, in accord with Subsection b above.)
+
+The source code for a work means the preferred form of the work for
+making modifications to it.  For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable.  However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+  4. You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License.  Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+
+  5. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Program or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+
+  6. Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+  7. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+  8. If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded.  In such case, this License incorporates
+the limitation as if written in the body of this License.
+
+  9. The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Program
+specifies a version number of this License which applies to it and "any
+later version", you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation.  If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+
+  10. If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission.  For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this.  Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+
+			    NO WARRANTY
+
+  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+
+  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+
+		     END OF TERMS AND CONDITIONS
+
+	    How to Apply These Terms to Your New Programs
+
+  If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+  To do so, attach the following notices to the program.  It is safest
+to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the program's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License along
+    with this program; if not, write to the Free Software Foundation, Inc.,
+    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+Also add information on how to contact you by electronic and paper mail.
+
+If the program is interactive, make it output a short notice like this
+when it starts in an interactive mode:
+
+    Gnomovision version 69, Copyright (C) year name of author
+    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+    This is free software, and you are welcome to redistribute it
+    under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License.  Of course, the commands you use may
+be called something other than `show w' and `show c'; they could even be
+mouse-clicks or menu items--whatever suits your program.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the program, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
+  `Gnomovision' (which makes passes at compilers) written by James Hacker.
+
+  <signature of Ty Coon>, 1 April 1989
+  Ty Coon, President of Vice
+
+This General Public License does not permit incorporating your program into
+proprietary programs.  If your program is a subroutine library, you may
+consider it more useful to permit linking proprietary applications with the
+library.  If this is what you want to do, use the GNU Lesser General
+Public License instead of this License.
Index: /extensions/pwgCumulus/CREDITS
===================================================================
--- /extensions/pwgCumulus/CREDITS	(revision 5201)
+++ /extensions/pwgCumulus/CREDITS	(revision 5201)
@@ -0,0 +1,3 @@
+Merci à Roy Tanck (http://www.roytanck.com/) pour son animation flash.
+
+Thanks to Roy Tanck (http://www.roytanck.com/) for it's marvelous flash movie.
Index: /extensions/pwgCumulus/MANIFEST
===================================================================
--- /extensions/pwgCumulus/MANIFEST	(revision 5201)
+++ /extensions/pwgCumulus/MANIFEST	(revision 5201)
@@ -0,0 +1,27 @@
+./CREDITS
+./imgs/cumulus3d.png
+./MANIFEST
+./maintain.inc.php
+./template/tags.tpl
+./template/admin.tpl
+./js/swfobject.js
+./js/farbtastic.js
+./main.inc.php
+./default_values.inc.php
+./language/fr_FR/plugin.lang.php
+./language/en_UK/plugin.lang.php
+./CHANGELOG
+./include/pwgCumulusContent.class.php
+./include/pwgCumulusConfig.class.php
+./swf/tagcloud.swf
+./admin.php
+./Makefile
+./COPYING
+./css/admin.css
+./css/imgs/wheel.png
+./css/imgs/mask.png
+./css/imgs/marker.png
+./css/farbtastic.css
+./init.php
+./public.php
+./TODO
Index: /extensions/pwgCumulus/TODO
===================================================================
--- /extensions/pwgCumulus/TODO	(revision 5201)
+++ /extensions/pwgCumulus/TODO	(revision 5201)
@@ -0,0 +1,6 @@
+Paramétrages :
+- couleur de fond
+- couleur texte1
+- couleur texte2
+- couleur au survol
+- vitesse de rotation
Index: /extensions/pwgCumulus/admin.php
===================================================================
--- /extensions/pwgCumulus/admin.php	(revision 5201)
+++ /extensions/pwgCumulus/admin.php	(revision 5201)
@@ -0,0 +1,107 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | pwgCumulus  - a plugin for Piwigo                                     |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2009      Nicolas Roudaire        http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+if (!defined('PHPWG_ROOT_PATH')) {
+  die('Hacking attempt!');
+}
+
+add_event_handler('loc_end_page_header', 'pwg_cumulus_addAssets');
+
+load_language('plugin.lang', PWG_CUMULUS_PLUGIN_LANG);
+
+$me = get_plugin_data($plugin_id);
+$save_config = false;
+
+if (!empty($_POST['submit'])) {
+  if (!empty($_POST['pwg_cumulus_width']) && intval($_POST['pwg_cumulus_width'])!=$me->pwg_cumulus_width) {
+    $me->pwg_cumulus_width = intval($_POST['pwg_cumulus_width']);
+    array_push($GLOBALS['page']['infos'], $lang['pwg_cumulus_width_changed']);
+    $save_config = true;
+  }
+  if (!empty($_POST['pwg_cumulus_height']) && intval($_POST['pwg_cumulus_height'])!=$me->pwg_cumulus_height) {
+    $me->pwg_cumulus_height = intval($_POST['pwg_cumulus_height']);
+    array_push($GLOBALS['page']['infos'], $lang['pwg_cumulus_height_changed']);
+    $save_config = true;
+  }
+  if (!empty($_POST['pwg_cumulus_coeff']) && intval($_POST['pwg_cumulus_coeff'])!=$me->pwg_cumulus_coeff) {
+    $me->pwg_cumulus_coeff = intval($_POST['pwg_cumulus_coeff']);
+    array_push($GLOBALS['page']['infos'], $lang['pwg_cumulus_coeff_changed']);
+    $save_config = true;
+  }
+
+  if (!empty($_POST['pwg_cumulus_color1']) && trim($_POST['pwg_cumulus_color1'])!=$me->pwg_cumulus_color1) {
+    //    $me->pwg_cumulus_color1 = trim($_POST['pwg_cumulus_color1'], " /\n\t\r\0\x0B");
+    $me->pwg_cumulus_color1 = $_POST['pwg_cumulus_color1'];
+    array_push($GLOBALS['page']['infos'], $lang['pwg_cumulus_color1_changed']);
+    $save_config = true;
+  }
+  if (!empty($_POST['pwg_cumulus_color2']) && trim($_POST['pwg_cumulus_color2'])!=$me->pwg_cumulus_color2) {
+    //    $me->pwg_cumulus_color2 = trim($_POST['pwg_cumulus_color2'], " /\n\t\r\0\x0B");
+    $me->pwg_cumulus_color2 = $_POST['pwg_cumulus_color2'];
+    array_push($GLOBALS['page']['infos'], $lang['pwg_cumulus_color2_changed']);
+    $save_config = true;
+  }
+  if (!empty($_POST['pwg_cumulus_hicolor']) && trim($_POST['pwg_cumulus_hicolor'])!=$me->pwg_cumulus_hicolor) {
+    //    $me->pwg_cumulus_hicolor = trim($_POST['pwg_cumulus_hicolor'], " /\n\t\r\0\x0B");
+    $me->pwg_cumulus_hicolor = $_POST['pwg_cumulus_hicolor'];
+    array_push($GLOBALS['page']['infos'], $lang['pwg_cumulus_hicolor_changed']);
+    $save_config = true;
+  }
+
+  if ($save_config) {
+    $me->save_config();
+  }
+}
+
+$GLOBALS['template']->set_filenames(array('plugin_admin_content' => PWG_CUMULUS_PLUGIN_TEMPLATE . '/admin.tpl'));
+$GLOBALS['template']->assign('PWG_CUMULUS_WIDTH', $me->pwg_cumulus_width); 
+$GLOBALS['template']->assign('PWG_CUMULUS_HEIGHT', $me->pwg_cumulus_height); 
+$GLOBALS['template']->assign('PWG_CUMULUS_COEFF', $me->pwg_cumulus_coeff); 
+$GLOBALS['template']->assign('PWG_CUMULUS_COLOR1', $me->pwg_cumulus_color1);
+$GLOBALS['template']->assign('PWG_CUMULUS_COLOR2', $me->pwg_cumulus_color2);
+$GLOBALS['template']->assign('PWG_CUMULUS_HICOLOR', $me->pwg_cumulus_hicolor);
+$GLOBALS['template']->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
+
+function pwg_cumulus_addAssets() {
+  $css_format = '<link rel="stylesheet" type="text/css" href="%s/%s.css">'."\n";
+  $js_format = '<script type="text/javascript" src="%s"></script>'."\n";
+  
+  $GLOBALS['template']->append('head_elements', 
+			       sprintf($css_format,
+				       PWG_CUMULUS_PLUGIN_CSS,
+				       'admin'
+				       )
+			       );
+  $GLOBALS['template']->append('head_elements', 
+			       sprintf($css_format,
+				       PWG_CUMULUS_PLUGIN_CSS,
+				       'farbtastic'
+				       )
+			       );
+  $GLOBALS['template']->func_known_script(array('id' => 'farbtastic',
+						'src' => PWG_CUMULUS_PLUGIN_JS. '/farbtastic.js'
+						),
+					  $GLOBALS['template']->smarty
+					  );
+
+
+}
+?>
Index: /extensions/pwgCumulus/css/admin.css
===================================================================
--- /extensions/pwgCumulus/css/admin.css	(revision 5201)
+++ /extensions/pwgCumulus/css/admin.css	(revision 5201)
@@ -0,0 +1,32 @@
+form fieldset { 
+  text-align: left;
+}
+
+form p.field, p { 
+  text-align: left;
+  margin-left: 20px;
+}
+
+label {
+  display : block;
+}
+
+p.field {
+  position: relative;
+}
+
+p.field label {
+  display: block;
+  width: 14em;
+}
+
+p.field input {
+  display: inline;
+  position: absolute;
+  left: 15em;
+  top: 0;
+}
+
+
+
+
Index: /extensions/pwgCumulus/css/farbtastic.css
===================================================================
--- /extensions/pwgCumulus/css/farbtastic.css	(revision 5201)
+++ /extensions/pwgCumulus/css/farbtastic.css	(revision 5201)
@@ -0,0 +1,43 @@
+.farbtastic {
+  position: relative;
+}
+.farbtastic * {
+  position: absolute;
+  cursor: crosshair;
+}
+.farbtastic, .farbtastic .wheel {
+  width: 195px;
+  height: 195px;
+}
+.farbtastic .color, .farbtastic .overlay {
+  top: 47px;
+  left: 47px;
+  width: 101px;
+  height: 101px;
+}
+.farbtastic .wheel {
+  background: url(imgs/wheel.png) no-repeat;
+  width: 195px;
+  height: 195px;
+}
+.farbtastic .overlay {
+  background: url(imgs/mask.png) no-repeat;
+}
+.farbtastic .marker {
+  width: 17px;
+  height: 17px;
+  margin: -8px 0 0 -8px;
+  overflow: hidden; 
+  background: url(imgs/marker.png) no-repeat;
+}
+
+.colorwell {
+  border: 2px solid #fff;
+  width: 6em;
+  text-align: center;
+  cursor: pointer;
+}
+body .colorwell-selected {
+  border: 2px solid #000;
+  font-weight: bold;
+}
Index: /extensions/pwgCumulus/default_values.inc.php
===================================================================
--- /extensions/pwgCumulus/default_values.inc.php	(revision 5201)
+++ /extensions/pwgCumulus/default_values.inc.php	(revision 5201)
@@ -0,0 +1,29 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | pwgCumulus  - a plugin for Piwigo                                     |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2009      Nicolas Roudaire        http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+$default_values['pwg_cumulus_width'] = 600;
+$default_values['pwg_cumulus_height'] = 400;
+$default_values['pwg_cumulus_coeff'] = 10;
+
+$default_values['color1'] = "#333333";
+$default_values['color2'] = "#FF3363";
+$default_values['hicolor'] = "#00CC00";
+?>
Index: /extensions/pwgCumulus/include/pwgCumulusConfig.class.php
===================================================================
--- /extensions/pwgCumulus/include/pwgCumulusConfig.class.php	(revision 5201)
+++ /extensions/pwgCumulus/include/pwgCumulusConfig.class.php	(revision 5201)
@@ -0,0 +1,90 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | pwgCumulus  - a plugin for Piwigo                                     |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2009      Nicolas Roudaire        http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+class pwgCumulusConfig
+{
+  private 
+    $config = array(), 
+    $plugin_dir;
+
+  public function __construct($plugin_dir, $plugin_name) {
+    $this->plugin_dir = $plugin_dir;
+    $this->plugin_name = $plugin_name;
+
+    if (!file_exists($this->get_config_file_dir())) {
+      mkgetdir($this->get_config_file_dir());
+    }
+
+    if (!file_exists($this->get_config_filename())) {
+      $this->save_config();
+    }
+  }
+
+  public function load_config() {
+    $x = file_get_contents($this->get_config_filename());
+    if ($x!==false) {
+      $c = unserialize($x);
+      $this->config = $c;
+    }
+    $this->setDefaults();
+  }
+
+  public function save_config() {
+    file_put_contents($this->get_config_filename(), serialize($this->config));
+  }
+
+  private function get_config_file_dir() {
+    return $GLOBALS['conf']['local_data_dir'].'/plugins/';
+  }
+
+  private function get_config_filename() {
+    return $this->get_config_file_dir().basename($this->plugin_dir).'.dat';
+  }
+
+  public function __set($key, $value) {
+    // need filters ??
+    $this->config[$key] = $value;
+  }
+
+  public function __get($key) {
+    return isset($this->config[$key])?$this->config[$key]:null;
+  }
+
+  public function plugin_admin_menu($menu) {
+    array_push($menu,
+	       array('NAME' => $this->plugin_name,
+		     'URL' => get_admin_plugin_menu_link($this->plugin_dir.'/admin.php')		 
+		     )
+	       );
+    return $menu;
+  }
+
+  private function setDefaults() {
+    include_once $this->plugin_dir.'/default_values.inc.php';
+
+    foreach ($default_values as $key => $value) {
+      if (empty($this->config[$key])) {
+	$this->config[$key] = $value;
+      }
+    }
+  }
+}
+?>
Index: /extensions/pwgCumulus/include/pwgCumulusContent.class.php
===================================================================
--- /extensions/pwgCumulus/include/pwgCumulusContent.class.php	(revision 5201)
+++ /extensions/pwgCumulus/include/pwgCumulusContent.class.php	(revision 5201)
@@ -0,0 +1,60 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | pwgCumulus  - a plugin for Piwigo                                     |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2009      Nicolas Roudaire        http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+class pwgCumulusContent
+{
+  public function __construct($config) {
+    $this->plugin_config = $config;
+
+  }
+
+  public function loc_begin_page_header() {
+    if (!empty($_GET['display_mode']) && $_GET['display_mode']=='cumulus') {
+      $GLOBALS['template']->assign('display_mode', 'cumulus');
+    }
+
+    $GLOBALS['template']->set_filenames(array('tags'=> PWG_CUMULUS_PLUGIN_TEMPLATE . '/tags.tpl'));
+    $GLOBALS['template']->func_known_script(array('id' => 'swfobject',
+						  'src' => PWG_CUMULUS_PLUGIN_JS. '/swfobject.js'
+						  ),
+					    $GLOBALS['template']->smarty
+					    );
+    
+    $GLOBALS['template']->assign('PWG_CUMULUS_SWF', PWG_CUMULUS_PLUGIN_SWF);
+    $GLOBALS['template']->assign('PWG_CUMULUS_IMGS', PWG_CUMULUS_PLUGIN_IMGS);
+
+    $GLOBALS['template']->assign('PWG_CUMULUS_WIDTH', $this->plugin_config->pwg_cumulus_width);
+    $GLOBALS['template']->assign('PWG_CUMULUS_HEIGHT', $this->plugin_config->pwg_cumulus_height);
+    $GLOBALS['template']->assign('PWG_CUMULUS_HREF', get_root_url().'tags.php?display_mode=cumulus');
+
+    $GLOBALS['template']->assign('PWG_CUMULUS_COLOR1', '0x'.substr($this->plugin_config->pwg_cumulus_color1,1));
+    $GLOBALS['template']->assign('PWG_CUMULUS_COLOR2', '0x'.substr($this->plugin_config->pwg_cumulus_color2,1));
+    $GLOBALS['template']->assign('PWG_CUMULUS_HICOLOR', '0x'.substr($this->plugin_config->pwg_cumulus_hicolor,1));
+
+    if (!empty($GLOBALS['template']->smarty->_tpl_vars['tags'])) {
+      foreach ($GLOBALS['template']->smarty->_tpl_vars['tags'] as $key => &$tag) {
+	$tag['display_name'] = urlencode($tag['name']);
+	$tag['size'] = $this->plugin_config->pwg_cumulus_coeff*$tag['level'];
+      }
+    }
+  }
+}
+?>
Index: /extensions/pwgCumulus/init.php
===================================================================
--- /extensions/pwgCumulus/init.php	(revision 5201)
+++ /extensions/pwgCumulus/init.php	(revision 5201)
@@ -0,0 +1,49 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | pwgCumulus  - a plugin for Piwigo                                     |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2009      Nicolas Roudaire        http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+if (!defined('PHPWG_ROOT_PATH')) {
+  die('Hacking attempt!');
+}
+
+define('PWG_CUMULUS_PLUGIN_NAME', 'Cumulus Tags Cloud');
+define('PWG_CUMULUS_PLUGIN_ROOT', dirname(__FILE__));
+define('PWG_CUMULUS_PLUGIN_LANG', PWG_CUMULUS_PLUGIN_ROOT . '/');
+define('PWG_CUMULUS_PLUGIN_TEMPLATE', PWG_CUMULUS_PLUGIN_ROOT . '/template');
+define('PWG_CUMULUS_PLUGIN_CSS', PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)). '/css');
+define('PWG_CUMULUS_PLUGIN_JS', PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)). '/js');
+define('PWG_CUMULUS_PLUGIN_SWF', PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)). '/swf');
+define('PWG_CUMULUS_PLUGIN_IMGS', PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)). '/imgs');
+
+include_once "include/pwgCumulusConfig.class.php";
+
+load_language('plugin.lang', PWG_CUMULUS_PLUGIN_LANG);
+
+$plugin_config = new pwgCumulusConfig(PWG_CUMULUS_PLUGIN_ROOT, PWG_CUMULUS_PLUGIN_NAME);
+$plugin_config->load_config();
+
+if (defined('IN_ADMIN')) { 
+  add_event_handler('get_admin_plugin_menu_links', array($plugin_config, 'plugin_admin_menu')); 
+} else {
+  include_once PWG_CUMULUS_PLUGIN_ROOT . '/public.php';
+}
+
+set_plugin_data($plugin['id'], $plugin_config);
+?>
Index: /extensions/pwgCumulus/js/farbtastic.js
===================================================================
--- /extensions/pwgCumulus/js/farbtastic.js	(revision 5201)
+++ /extensions/pwgCumulus/js/farbtastic.js	(revision 5201)
@@ -0,0 +1,347 @@
+// $Id: farbtastic.js,v 1.2 2007/01/08 22:53:01 unconed Exp $
+// Farbtastic 1.2
+
+jQuery.fn.farbtastic = function (callback) {
+  $.farbtastic(this, callback);
+  return this;
+};
+
+jQuery.farbtastic = function (container, callback) {
+  var container = $(container).get(0);
+  return container.farbtastic || (container.farbtastic = new jQuery._farbtastic(container, callback));
+}
+
+  jQuery._farbtastic = function (container, callback) {
+    // Store farbtastic object
+    var fb = this;
+
+    // Insert markup
+    $(container).html('<div class="farbtastic"><div class="color"></div><div class="wheel"></div><div class="overlay"></div><div class="h-marker marker"></div><div class="sl-marker marker"></div></div>');
+    var e = $('.farbtastic', container);
+    fb.wheel = $('.wheel', container).get(0);
+    // Dimensions
+    fb.radius = 84;
+    fb.square = 100;
+    fb.width = 194;
+
+    // Fix background PNGs in IE6
+    if (navigator.appVersion.match(/MSIE [0-6]\./)) {
+      $('*', e).each(function () {
+	  if (this.currentStyle.backgroundImage != 'none') {
+	    var image = this.currentStyle.backgroundImage;
+	    image = this.currentStyle.backgroundImage.substring(5, image.length - 2);
+	    $(this).css({
+		'backgroundImage': 'none',
+		  'filter': "progid:DXImageTransform.Microsoft.AlphaImageLoader(enabled=true, sizingMethod=crop, src='" + image + "')"
+		  });
+	  }
+	});
+    }
+
+    /**
+     * Link to the given element(s) or callback.
+     */
+    fb.linkTo = function (callback) {
+      // Unbind previous nodes
+      if (typeof fb.callback == 'object') {
+	$(fb.callback).unbind('keyup', fb.updateValue);
+      }
+
+      // Reset color
+      fb.color = null;
+
+      // Bind callback or elements
+      if (typeof callback == 'function') {
+	fb.callback = callback;
+      }
+      else if (typeof callback == 'object' || typeof callback == 'string') {
+	fb.callback = $(callback);
+	fb.callback.bind('keyup', fb.updateValue);
+	if (fb.callback.get(0).value) {
+	  fb.setColor(fb.callback.get(0).value);
+	}
+      }
+      return this;
+    }
+    fb.updateValue = function (event) {
+      if (this.value && this.value != fb.color) {
+	fb.setColor(this.value);
+      }
+    }
+
+    /**
+     * Change color with HTML syntax #123456
+     */
+    fb.setColor = function (color) {
+      var unpack = fb.unpack(color);
+      if (fb.color != color && unpack) {
+	fb.color = color;
+	fb.rgb = unpack;
+	fb.hsl = fb.RGBToHSL(fb.rgb);
+	fb.updateDisplay();
+      }
+      return this;
+    }
+
+    /**
+     * Change color with HSL triplet [0..1, 0..1, 0..1]
+     */
+    fb.setHSL = function (hsl) {
+      fb.hsl = hsl;
+      fb.rgb = fb.HSLToRGB(hsl);
+      fb.color = fb.pack(fb.rgb);
+      fb.updateDisplay();
+      return this;
+    }
+
+    /////////////////////////////////////////////////////
+
+    /**
+     * Retrieve the coordinates of the given event relative to the center
+     * of the widget.
+     */
+    fb.widgetCoords = function (event) {
+      var x, y;
+      var el = event.target || event.srcElement;
+      var reference = fb.wheel;
+
+      if (typeof event.offsetX != 'undefined') {
+	// Use offset coordinates and find common offsetParent
+	var pos = { x: event.offsetX, y: event.offsetY };
+
+	// Send the coordinates upwards through the offsetParent chain.
+	var e = el;
+	while (e) {
+	  e.mouseX = pos.x;
+	  e.mouseY = pos.y;
+	  pos.x += e.offsetLeft;
+	  pos.y += e.offsetTop;
+	  e = e.offsetParent;
+	}
+
+	// Look for the coordinates starting from the wheel widget.
+	var e = reference;
+	var offset = { x: 0, y: 0 }
+	while (e) {
+	  if (typeof e.mouseX != 'undefined') {
+	    x = e.mouseX - offset.x;
+	    y = e.mouseY - offset.y;
+	    break;
+	  }
+	  offset.x += e.offsetLeft;
+	  offset.y += e.offsetTop;
+	  e = e.offsetParent;
+	}
+
+	// Reset stored coordinates
+	e = el;
+	while (e) {
+	  e.mouseX = undefined;
+	  e.mouseY = undefined;
+	  e = e.offsetParent;
+	}
+      }
+      else {
+	// Use absolute coordinates
+	var pos = fb.absolutePosition(reference);
+	x = (event.pageX || 0*(event.clientX + $('html').get(0).scrollLeft)) - pos.x;
+	y = (event.pageY || 0*(event.clientY + $('html').get(0).scrollTop)) - pos.y;
+      }
+      // Subtract distance to middle
+      return { x: x - fb.width / 2, y: y - fb.width / 2 };
+    }
+
+    /**
+     * Mousedown handler
+     */
+    fb.mousedown = function (event) {
+      // Capture mouse
+      if (!document.dragging) {
+	$(document).bind('mousemove', fb.mousemove).bind('mouseup', fb.mouseup);
+	document.dragging = true;
+      }
+
+      // Check which area is being dragged
+      var pos = fb.widgetCoords(event);
+      fb.circleDrag = Math.max(Math.abs(pos.x), Math.abs(pos.y)) * 2 > fb.square;
+
+      // Process
+      fb.mousemove(event);
+      return false;
+    }
+
+    /**
+     * Mousemove handler
+     */
+    fb.mousemove = function (event) {
+      // Get coordinates relative to color picker center
+      var pos = fb.widgetCoords(event);
+
+      // Set new HSL parameters
+      if (fb.circleDrag) {
+	var hue = Math.atan2(pos.x, -pos.y) / 6.28;
+	if (hue < 0) hue += 1;
+	fb.setHSL([hue, fb.hsl[1], fb.hsl[2]]);
+      }
+      else {
+	var sat = Math.max(0, Math.min(1, -(pos.x / fb.square) + .5));
+	var lum = Math.max(0, Math.min(1, -(pos.y / fb.square) + .5));
+	fb.setHSL([fb.hsl[0], sat, lum]);
+      }
+      return false;
+    }
+
+    /**
+     * Mouseup handler
+     */
+    fb.mouseup = function () {
+      // Uncapture mouse
+      $(document).unbind('mousemove', fb.mousemove);
+      $(document).unbind('mouseup', fb.mouseup);
+      document.dragging = false;
+    }
+
+    /**
+     * Update the markers and styles
+     */
+    fb.updateDisplay = function () {
+      // Markers
+      var angle = fb.hsl[0] * 6.28;
+      $('.h-marker', e).css({
+	left: Math.round(Math.sin(angle) * fb.radius + fb.width / 2) + 'px',
+	    top: Math.round(-Math.cos(angle) * fb.radius + fb.width / 2) + 'px'
+	    });
+
+      $('.sl-marker', e).css({
+	left: Math.round(fb.square * (.5 - fb.hsl[1]) + fb.width / 2) + 'px',
+	    top: Math.round(fb.square * (.5 - fb.hsl[2]) + fb.width / 2) + 'px'
+	    });
+
+      // Saturation/Luminance gradient
+      $('.color', e).css('backgroundColor', fb.pack(fb.HSLToRGB([fb.hsl[0], 1, 0.5])));
+
+      // Linked elements or callback
+      if (typeof fb.callback == 'object') {
+	// Set background/foreground color
+	$(fb.callback).css({
+	  backgroundColor: fb.color,
+	      color: fb.hsl[2] > 0.5 ? '#000' : '#fff'
+	      });
+
+	// Change linked value
+	$(fb.callback).each(function() {
+	    if (this.value && this.value != fb.color) {
+	      this.value = fb.color;
+	    }
+	  });
+      }
+      else if (typeof fb.callback == 'function') {
+	fb.callback.call(fb, fb.color);
+      }
+    }
+
+    /**
+     * Get absolute position of element
+     */
+    fb.absolutePosition = function (el) {
+      var r = { x: el.offsetLeft, y: el.offsetTop };
+      // Resolve relative to offsetParent
+      if (el.offsetParent) {
+	var tmp = fb.absolutePosition(el.offsetParent);
+	r.x += tmp.x;
+	r.y += tmp.y;
+      }
+      return r;
+    };
+
+    /* Various color utility functions */
+    fb.pack = function (rgb) {
+      var r = Math.round(rgb[0] * 255);
+      var g = Math.round(rgb[1] * 255);
+      var b = Math.round(rgb[2] * 255);
+      return '#' + (r < 16 ? '0' : '') + r.toString(16) +
+      (g < 16 ? '0' : '') + g.toString(16) +
+      (b < 16 ? '0' : '') + b.toString(16);
+    }
+
+    fb.unpack = function (color) {
+      if (color.length == 7) {
+	return [parseInt('0x' + color.substring(1, 3)) / 255,
+		parseInt('0x' + color.substring(3, 5)) / 255,
+		parseInt('0x' + color.substring(5, 7)) / 255];
+      }
+      else if (color.length == 4) {
+	return [parseInt('0x' + color.substring(1, 2)) / 15,
+		parseInt('0x' + color.substring(2, 3)) / 15,
+		parseInt('0x' + color.substring(3, 4)) / 15];
+      }
+    }
+
+    fb.HSLToRGB = function (hsl) {
+      var m1, m2, r, g, b;
+      var h = hsl[0], s = hsl[1], l = hsl[2];
+      m2 = (l <= 0.5) ? l * (s + 1) : l + s - l*s;
+      m1 = l * 2 - m2;
+      return [this.hueToRGB(m1, m2, h+0.33333),
+	      this.hueToRGB(m1, m2, h),
+	      this.hueToRGB(m1, m2, h-0.33333)];
+    }
+
+    fb.hueToRGB = function (m1, m2, h) {
+      h = (h < 0) ? h + 1 : ((h > 1) ? h - 1 : h);
+      if (h * 6 < 1) return m1 + (m2 - m1) * h * 6;
+      if (h * 2 < 1) return m2;
+      if (h * 3 < 2) return m1 + (m2 - m1) * (0.66666 - h) * 6;
+      return m1;
+    }
+
+    fb.RGBToHSL = function (rgb) {
+      var min, max, delta, h, s, l;
+      var r = rgb[0], g = rgb[1], b = rgb[2];
+      min = Math.min(r, Math.min(g, b));
+      max = Math.max(r, Math.max(g, b));
+      delta = max - min;
+      l = (min + max) / 2;
+      s = 0;
+      if (l > 0 && l < 1) {
+	s = delta / (l < 0.5 ? (2 * l) : (2 - 2 * l));
+      }
+      h = 0;
+      if (delta > 0) {
+	if (max == r && max != g) h += (g - b) / delta;
+	if (max == g && max != b) h += (2 + (b - r) / delta);
+	if (max == b && max != r) h += (4 + (r - g) / delta);
+	h /= 6;
+      }
+      return [h, s, l];
+    }
+
+    // Install mousedown handler (the others are set on the document on-demand)
+    $('*', e).mousedown(fb.mousedown);
+
+    // Init color
+    fb.setColor('#000000');
+
+    // Set linked elements/callback
+    if (callback) {
+      fb.linkTo(callback);
+    }
+  };
+
+$(function() {
+    var f = $.farbtastic('#picker');
+    var p = $('#picker').hide().css('opacity', 0.25);
+    var selected;
+    $('.colorwell')
+      .each(function () { f.linkTo(this); $(this).css('opacity', 0.75); })
+      .focus(function(e) {
+	  p.slideDown();
+	  if (selected) {
+	    $(selected)
+	      .css('opacity', 0.75).removeClass('colorwell-selected');
+	  }
+	  f.linkTo(this);
+	  p.css('opacity', 1);
+	  $(selected = this).css('opacity', 1).addClass('colorwell-selected');
+	});
+  });
Index: /extensions/pwgCumulus/js/swfobject.js
===================================================================
--- /extensions/pwgCumulus/js/swfobject.js	(revision 5201)
+++ /extensions/pwgCumulus/js/swfobject.js	(revision 5201)
@@ -0,0 +1,133 @@
+/**
+ * SWFObject v1.4: Flash Player detection and embed - http://blog.deconcept.com/swfobject/
+ *
+ * SWFObject is (c) 2006 Geoff Stearns and is released under the MIT License:
+ * http://www.opensource.org/licenses/mit-license.php
+ *
+ * **SWFObject is the SWF embed script formarly known as FlashObject. The name was changed for
+ *   legal reasons.
+ */
+if(typeof deconcept=="undefined"){var deconcept=new Object();}
+if(typeof deconcept.util=="undefined"){deconcept.util=new Object();}
+if(typeof deconcept.SWFObjectUtil=="undefined"){deconcept.SWFObjectUtil=new Object();}
+deconcept.SWFObject=function(_1,id,w,h,_5,c,_7,_8,_9,_a,_b){
+if(!document.createElement||!document.getElementById){return;}
+this.DETECT_KEY=_b?_b:"detectflash";
+this.skipDetect=deconcept.util.getRequestParameter(this.DETECT_KEY);
+this.params=new Object();
+this.variables=new Object();
+this.attributes=new Array();
+if(_1){this.setAttribute("swf",_1);}
+if(id){this.setAttribute("id",id);}
+if(w){this.setAttribute("width",w);}
+if(h){this.setAttribute("height",h);}
+if(_5){this.setAttribute("version",new deconcept.PlayerVersion(_5.toString().split(".")));}
+this.installedVer=deconcept.SWFObjectUtil.getPlayerVersion(this.getAttribute("version"),_7);
+if(c){this.addParam("bgcolor",c);}
+var q=_8?_8:"high";
+this.addParam("quality",q);
+this.setAttribute("useExpressInstall",_7);
+this.setAttribute("doExpressInstall",false);
+var _d=(_9)?_9:window.location;
+this.setAttribute("xiRedirectUrl",_d);
+this.setAttribute("redirectUrl","");
+if(_a){this.setAttribute("redirectUrl",_a);}};
+deconcept.SWFObject.prototype={setAttribute:function(_e,_f){
+this.attributes[_e]=_f;
+},getAttribute:function(_10){
+return this.attributes[_10];
+},addParam:function(_11,_12){
+this.params[_11]=_12;
+},getParams:function(){
+return this.params;
+},addVariable:function(_13,_14){
+this.variables[_13]=_14;
+},getVariable:function(_15){
+return this.variables[_15];
+},getVariables:function(){
+return this.variables;
+},getVariablePairs:function(){
+var _16=new Array();
+var key;
+var _18=this.getVariables();
+for(key in _18){
+_16.push(key+"="+_18[key]);}
+return _16;
+},getSWFHTML:function(){
+var _19="";
+if(navigator.plugins&&navigator.mimeTypes&&navigator.mimeTypes.length){
+if(this.getAttribute("doExpressInstall")){this.addVariable("MMplayerType","PlugIn");}
+_19="<embed type=\"application/x-shockwave-flash\" src=\""+this.getAttribute("swf")+"\" width=\""+this.getAttribute("width")+"\" height=\""+this.getAttribute("height")+"\"";
+_19+=" id=\""+this.getAttribute("id")+"\" name=\""+this.getAttribute("id")+"\" ";
+var _1a=this.getParams();
+for(var key in _1a){_19+=[key]+"=\""+_1a[key]+"\" ";}
+var _1c=this.getVariablePairs().join("&");
+if(_1c.length>0){_19+="flashvars=\""+_1c+"\"";}
+_19+="/>";
+}else{
+if(this.getAttribute("doExpressInstall")){this.addVariable("MMplayerType","ActiveX");}
+_19="<object id=\""+this.getAttribute("id")+"\" classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" width=\""+this.getAttribute("width")+"\" height=\""+this.getAttribute("height")+"\">";
+_19+="<param name=\"movie\" value=\""+this.getAttribute("swf")+"\" />";
+var _1d=this.getParams();
+for(var key in _1d){_19+="<param name=\""+key+"\" value=\""+_1d[key]+"\" />";}
+var _1f=this.getVariablePairs().join("&");
+if(_1f.length>0){_19+="<param name=\"flashvars\" value=\""+_1f+"\" />";}
+_19+="</object>";}
+return _19;
+},write:function(_20){
+if(this.getAttribute("useExpressInstall")){
+var _21=new deconcept.PlayerVersion([6,0,65]);
+if(this.installedVer.versionIsValid(_21)&&!this.installedVer.versionIsValid(this.getAttribute("version"))){
+this.setAttribute("doExpressInstall",true);
+this.addVariable("MMredirectURL",escape(this.getAttribute("xiRedirectUrl")));
+document.title=document.title.slice(0,47)+" - Flash Player Installation";
+this.addVariable("MMdoctitle",document.title);}}
+if(this.skipDetect||this.getAttribute("doExpressInstall")||this.installedVer.versionIsValid(this.getAttribute("version"))){
+var n=(typeof _20=="string")?document.getElementById(_20):_20;
+n.innerHTML=this.getSWFHTML();
+return true;
+}else{
+if(this.getAttribute("redirectUrl")!=""){document.location.replace(this.getAttribute("redirectUrl"));}}
+return false;}};
+deconcept.SWFObjectUtil.getPlayerVersion=function(_23,_24){
+var _25=new deconcept.PlayerVersion([0,0,0]);
+if(navigator.plugins&&navigator.mimeTypes.length){
+var x=navigator.plugins["Shockwave Flash"];
+if(x&&x.description){_25=new deconcept.PlayerVersion(x.description.replace(/([a-z]|[A-Z]|\s)+/,"").replace(/(\s+r|\s+b[0-9]+)/,".").split("."));}
+}else{try{
+var axo=new ActiveXObject("ShockwaveFlash.ShockwaveFlash");
+for(var i=3;axo!=null;i++){
+axo=new ActiveXObject("ShockwaveFlash.ShockwaveFlash."+i);
+_25=new deconcept.PlayerVersion([i,0,0]);}}
+catch(e){}
+if(_23&&_25.major>_23.major){return _25;}
+if(!_23||((_23.minor!=0||_23.rev!=0)&&_25.major==_23.major)||_25.major!=6||_24){
+try{_25=new deconcept.PlayerVersion(axo.GetVariable("$version").split(" ")[1].split(","));}
+catch(e){}}}
+return _25;};
+deconcept.PlayerVersion=function(_29){
+this.major=parseInt(_29[0])!=null?parseInt(_29[0]):0;
+this.minor=parseInt(_29[1])||0;
+this.rev=parseInt(_29[2])||0;};
+deconcept.PlayerVersion.prototype.versionIsValid=function(fv){
+if(this.major<fv.major){return false;}
+if(this.major>fv.major){return true;}
+if(this.minor<fv.minor){return false;}
+if(this.minor>fv.minor){return true;}
+if(this.rev<fv.rev){return false;}return true;};
+deconcept.util={getRequestParameter:function(_2b){
+var q=document.location.search||document.location.hash;
+if(q){
+var _2d=q.indexOf(_2b+"=");
+var _2e=(q.indexOf("&",_2d)>-1)?q.indexOf("&",_2d):q.length;
+if(q.length>1&&_2d>-1){
+return q.substring(q.indexOf("=",_2d)+1,_2e);
+}}return "";}};
+if(Array.prototype.push==null){
+Array.prototype.push=function(_2f){
+this[this.length]=_2f;
+return this.length;};}
+var getQueryParamValue=deconcept.util.getRequestParameter;
+var FlashObject=deconcept.SWFObject; // for backwards compatibility
+var SWFObject=deconcept.SWFObject;
+
Index: /extensions/pwgCumulus/language/en_UK/plugin.lang.php
===================================================================
--- /extensions/pwgCumulus/language/en_UK/plugin.lang.php	(revision 5201)
+++ /extensions/pwgCumulus/language/en_UK/plugin.lang.php	(revision 5201)
@@ -0,0 +1,40 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | pwgCumulus  - a plugin for Piwigo                                     |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2009      Nicolas Roudaire        http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+$lang['pwg_cumulus_title'] = "Cumulus Tags Cloud Plugin";
+$lang['pwg_cumulus_intro'] = "That plugin display tags using a flash movie that rotates them in 3D. It works like a regular tags cloud but in a more amazing and exciting way.";
+$lang['pwg_cumulus_info'] = "Vous can choose that mode for tags default display mode by adding (or changing) in the configuration file <strong>config_local.inc.php</strong>&nbsp;:&nbsp;<br>\$conf['tags_default_display_mode'] = 'cumulus';";
+$lang['pwg_cumulus_dimensions'] = "Animation width and height";
+$lang['pwg_cumulus_width'] = "Width";
+$lang['pwg_cumulus_height'] = "Height";
+$lang['pwg_cumulus_tags_size'] = "Tags size";
+$lang['pwg_cumulus_coeff'] = "Coefficient";
+$lang['pwg_cumulus_width_changed'] = "Width updated";
+$lang['pwg_cumulus_height_changed'] = "Height updated";
+$lang['pwg_cumulus_coeff_changed'] = "Coefficient for tags size updated";
+$lang['show tag cloud in cumulus mode'] = "Show tag cloud in cumulus mode";
+$lang['pwg_cumulus_color1'] = "Color 1";
+$lang['pwg_cumulus_color2'] = "Color 2";
+$lang['pwg_cumulus_hicolor'] = "Hover color";
+$lang['pwg_cumulus_color1_changed'] = "Color 1 updated";
+$lang['pwg_cumulus_color2_changed'] = "Color 2 updated";
+$lang['pwg_cumulus_hicolor_changed'] = "Hover color updated";
+?>
Index: /extensions/pwgCumulus/language/fr_FR/plugin.lang.php
===================================================================
--- /extensions/pwgCumulus/language/fr_FR/plugin.lang.php	(revision 5201)
+++ /extensions/pwgCumulus/language/fr_FR/plugin.lang.php	(revision 5201)
@@ -0,0 +1,40 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | pwgCumulus  - a plugin for Piwigo                                     |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2009      Nicolas Roudaire        http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+$lang['pwg_cumulus_title'] = "Plugin Cumulus Tags Cloud";
+$lang['pwg_cumulus_intro'] = "Ce plugin permet d'afficher un nuage de tags sous forme d'une animation flash en 3D.";
+$lang['pwg_cumulus_info'] = "Vous pouvez choisir ce mode d'affichage du nuage de tags en ajoutant le mode par défaut dans le fichier de configuration <strong>config_local.inc.php</strong>&nbsp;:&nbsp;<br>\$conf['tags_default_display_mode'] = 'cumulus';";
+$lang['pwg_cumulus_dimensions'] = "Dimensions de l'animation";
+$lang['pwg_cumulus_width'] = "Largeur";
+$lang['pwg_cumulus_height'] = "Hauteur";
+$lang['pwg_cumulus_tags_size'] = "Taille des tags";
+$lang['pwg_cumulus_coeff'] = "Coefficient";
+$lang['pwg_cumulus_width_changed'] = "La largeur a été mise à jour";
+$lang['pwg_cumulus_height_changed'] = "La hauteur a été mise à jour";
+$lang['pwg_cumulus_coeff_changed'] = "Le coefficient multiplicateur des tags a été mis à jour";
+$lang['show tag cloud in cumulus mode'] = "Utiliser le mode cumulus pour afficher le nuage de tags";
+$lang['pwg_cumulus_color1'] = "Couleur 1";
+$lang['pwg_cumulus_color2'] = "Couleur 2";
+$lang['pwg_cumulus_hicolor'] = "Couleur au survol";
+$lang['pwg_cumulus_color1_changed'] = "La couleur 1 a été mise à jour";
+$lang['pwg_cumulus_color2_changed'] = "La couleur 2 a été mise à jour";
+$lang['pwg_cumulus_hicolor_changed'] = "La couleur hicolor a été mise à jour";
+?>
Index: /extensions/pwgCumulus/main.inc.php
===================================================================
--- /extensions/pwgCumulus/main.inc.php	(revision 5201)
+++ /extensions/pwgCumulus/main.inc.php	(revision 5201)
@@ -0,0 +1,36 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | pwgCumulus  - a plugin for Piwigo                                     |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2009      Nicolas Roudaire        http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+/*
+Plugin Name: pwgCumulus
+Version: 0.3.0
+Description: add an amazing tag cloud
+Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=263
+Author: nikrou
+Author URI: http://www.nikrou.net/
+*/
+
+if (!defined('PHPWG_ROOT_PATH')) {
+  die('Hacking attempt!');
+}
+
+include_once(dirname(__FILE__).'/init.php');
+?>
Index: /extensions/pwgCumulus/maintain.inc.php
===================================================================
--- /extensions/pwgCumulus/maintain.inc.php	(revision 5201)
+++ /extensions/pwgCumulus/maintain.inc.php	(revision 5201)
@@ -0,0 +1,37 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | pwgCumulus  - a plugin for Piwigo                                     |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2009      Nicolas Roudaire        http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+if (!defined('PHPWG_ROOT_PATH')) {
+  die('Hacking attempt!');
+}
+
+function plugin_install($plugin_id, $plugin_version, &$errors) {
+}
+
+function plugin_activate($plugin_id, $plugin_version, &$errors) {
+}
+
+function plugin_deactivate($plugin_id) { 
+}
+
+function plugin_uninstall($plugin_id) {
+}
+?>
Index: /extensions/pwgCumulus/public.php
===================================================================
--- /extensions/pwgCumulus/public.php	(revision 5201)
+++ /extensions/pwgCumulus/public.php	(revision 5201)
@@ -0,0 +1,27 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | pwgCumulus  - a plugin for Piwigo                                     |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2009      Nicolas Roudaire        http://www.nikrou.net  |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+include_once PWG_CUMULUS_PLUGIN_ROOT . "/include/pwgCumulusContent.class.php";
+
+$public_content = new pwgCumulusContent($plugin_config);
+
+add_event_handler('loc_begin_page_header', array($public_content, 'loc_begin_page_header')); 
+?>
Index: /extensions/pwgCumulus/template/admin.tpl
===================================================================
--- /extensions/pwgCumulus/template/admin.tpl	(revision 5201)
+++ /extensions/pwgCumulus/template/admin.tpl	(revision 5201)
@@ -0,0 +1,57 @@
+<div class="titrePage">
+  <h2>{'pwg_cumulus_title'|@translate}</h2>
+</div>
+
+<p>
+{'pwg_cumulus_intro'|@translate}
+</p>
+
+<p>
+{'pwg_cumulus_info'|@translate}
+</p>
+
+<form method="post" action="" class="general">
+<fieldset>
+  <legend>{'pwg_cumulus_dimensions'|@translate}</legend>
+  <p class="field">
+    <label>{'pwg_cumulus_width'|@translate}
+      <input type="text" name="pwg_cumulus_width" value="{$PWG_CUMULUS_WIDTH}">
+    </label>
+  </p>
+  <p class="field">
+    <label>{'pwg_cumulus_height'|@translate}
+      <input type="text" name="pwg_cumulus_height" value="{$PWG_CUMULUS_HEIGHT}">
+    </label>
+  </p>
+</fieldset>
+
+<fieldset>
+  <legend>{'pwg_cumulus_tags_size'|@translate}</legend>
+  <p class="field">
+    <label>{'pwg_cumulus_coeff'|@translate}
+      <input type="text" name="pwg_cumulus_coeff" value="{$PWG_CUMULUS_COEFF}">
+    </label>      
+  </p>
+</fieldset>
+
+<fieldset>
+  <legend>{'pwg_cumulus_colors'|@translate}</legend>
+  <div id="picker" style="float: right;"></div>
+  <p class="field">
+    <label>{'pwg_cumulus_color1'|@translate}
+      <input class="colorwell" type="text" name="pwg_cumulus_color1" value="{$PWG_CUMULUS_COLOR1}">
+    </label>      
+  </p>
+  <p class="field">
+    <label>{'pwg_cumulus_color2'|@translate}
+      <input class="colorwell" type="text" name="pwg_cumulus_color2" value="{$PWG_CUMULUS_COLOR2}">
+    </label>      
+  </p>
+  <p class="field">
+    <label>{'pwg_cumulus_hicolor'|@translate}
+      <input class="colorwell" type="text" name="pwg_cumulus_hicolor" value="{$PWG_CUMULUS_HICOLOR}">
+    </label>      
+  </p>
+</fieldset>
+<p><input class="submit" type="submit" name="submit" value="{'Submit'|@translate}"></p>
+</form>
Index: /extensions/pwgCumulus/template/tags.tpl
===================================================================
--- /extensions/pwgCumulus/template/tags.tpl	(revision 5201)
+++ /extensions/pwgCumulus/template/tags.tpl	(revision 5201)
@@ -0,0 +1,77 @@
+<div id="content" class="content">
+
+  <div class="titrePage">
+    <ul class="categoryActions">
+
+      {if $display_mode != 'letters'}
+      <li><a href="{$U_LETTERS}" title="{'group by letters'|@translate}" rel="nofollow"><img src="{$themeconf.icon_dir}/tag_letters.png" class="button" alt="{'letters'|@translate}"></a></li>
+      {/if}
+
+      {if $display_mode != 'cumulus'}
+      <li><a href="{$PWG_CUMULUS_HREF}" title="{'show tag cloud in cumulus mode'|@translate}" rel="nofollow"><img src="{$PWG_CUMULUS_IMGS}/cumulus3d.png" class="button" alt="{'cumulus cloud'|@translate}"></a></li>
+      {/if}
+
+      {if $display_mode != 'cloud'}
+      <li><a href="{$U_CLOUD}" title="{'show tag cloud'|@translate}" rel="nofollow"><img src="{$themeconf.icon_dir}/tag_cloud.png" class="button" alt="{'cloud'|@translate}"></a></li>
+      {/if}
+
+      <li><a href="{$U_HOME}" title="{'return to homepage'|@translate}"><img src="{$themeconf.icon_dir}/home.png" class="button" alt="{'home'|@translate}"/></a></li>
+    </ul>
+    <h2>{'Tags'|@translate}</h2>
+  </div>
+
+  {if isset($tags)}
+  {if $display_mode == 'cloud'}
+  <div id="fullTagCloud">
+    {foreach from=$tags item=tag}
+    <span><a href="{$tag.URL}" class="tagLevel{$tag.level}" title="{$tag.counter}">{$tag.name}</a></span>
+    {/foreach}
+  </div>
+  {/if}
+
+  {if $display_mode == 'cumulus'}
+  <div id="flashcontent">This will be shown to users with no Flash or Javascript.</div>
+
+  <script type="text/javascript">
+    var so = new SWFObject("{$PWG_CUMULUS_SWF}/tagcloud.swf", "tagcloud", "{$PWG_CUMULUS_WIDTH}", "{$PWG_CUMULUS_HEIGHT}", "7", "#FFFFFF");
+    so.addParam("wmode", "transparent");
+    so.addVariable("tcolor", "{$PWG_CUMULUS_COLOR1}");
+    so.addVariable("tcolor2", "{$PWG_CUMULUS_COLOR2}");
+    so.addVariable("hicolor", "{$PWG_CUMULUS_HICOLOR}");
+    so.addVariable("mode", "tags");
+    so.addVariable("distr", "true");
+    so.addVariable("tspeed", "100");
+    so.addVariable("tagcloud", 
+    "<tags>{foreach from=$tags item=tag}<a href='{$tag.URL}' style='{$tag.size}pt'>{$tag.display_name}</a>{/foreach}</tags>");
+    so.write("flashcontent");
+  </script>
+  {/if}
+
+  {if $display_mode == 'letters'}
+  <table>
+    <tr>
+      <td valign="top">
+	{foreach from=$letters item=letter}
+	<fieldset class="tagLetter">
+	  <legend class="tagLetterLegend">{$letter.TITLE}</legend>
+	  <table class="tagLetterContent">
+	    {foreach from=$letter.tags item=tag}
+	    <tr class="tagLine">
+              <td><a href="{$tag.URL}">{$tag.name}</a></td>
+              <td class="nbEntries">{$pwg->l10n_dec('%d element', '%d elements', $tag.counter)}</td>
+	    </tr>
+	    {/foreach}
+	  </table>
+	</fieldset>
+	{if $letter.CHANGE_COLUMN|@default:false}
+      </td>
+      <td valign="top">
+	{/if}
+	{/foreach}
+      </td>
+    </tr>
+  </table>
+  {/if}
+  {/if}
+
+</div> <!-- content -->
